unit GDAL;

{$IFDEF FPC}
 {$mode objfpc}
 {$modeswitch cvar}
 {$IFDEF MSWINDOWS}
  {$packrecords default} //assume GDAL compiled with Visual C++, natural alignment
 {$ELSE}
  {$packrecords c} //assume GDAL compiled with GCC
 {$ENDIF}
{$ENDIF}

interface

uses
  ctypes;

const
{$IFDEF DARWIN}
 {$IFDEF GDAL_FRAMEWORK}
  {$linkframework GDAL}  //link against GDAL framework
  gdallib = '';
 {$ELSE}
  {$linklib gdal}
  gdallib = 'gdal';  //link against libgdal.dylib
 {$ENDIF}
{$ENDIF}

{$IFDEF MSWINDOWS}
  gdallib = 'gdal111';  //edit this to use a different library version
{$ENDIF}

{$IFDEF LINUX}
  gdallib = 'gdal';
{$ENDIF}

type
  charPtr = PAnsiChar;
  charPtrPtr = ^charPtr;
  charPtrPtrPtr = ^charPtrPtr;
  pointerPtr = ^Pointer;
  doublePtr = ^Double;
  doublePtrPtr = ^doublePtr;
  cintPtr = ^cint;
  cintPtrPtr = ^cintPtr;
  floatPtr = ^cfloat;
  clongPtr = ^clong;

  CPLErr = culong;  //for now - need to parse cpl_error.h?
  GIntBig = clong;  //for now - conditionally defined in cpl_port.h
  GInt16 = cshort;  //defined in cpl_port.h
  GByte = cuchar;  //GByte defined in cpl_port.h as "unsigned char"

  GIntBigPtr = ^GIntBig;
  GBytePtr = ^GByte;  //was using PAnsiChar
  FILEPtr = Pointer;
  OpaqueType = ^Pointer;
  GDALDatasetHPtr = Pointer;  //should have been GDALDataSetHPtrPtr? then ^^GDALDataSetH?
  CPLVirtualMemPtr = Pointer;
  OGRAxisOrientationPtr = Pointer;

   //in cpl_progress.h
  GDALProgressFunc = function (dfComplete: double; pszMessage: PAnsiChar; pProgressArg: Pointer): cint; cdecl;


{$define INTERFACE}

{$define TYPES}
{$include ./gdallib.inc}
{$undef TYPES}

{$define RECORDS}
{$include ./gdallib.inc}
{$undef RECORDS}

{$define PROTOCOLS}
{$include ./gdallib.inc}
{$undef PROTOCOLS}

{$define CLASSES}
{$include ./gdallib.inc}
{$undef CLASSES}

{$define FUNCTIONS}
{$include ./gdallib.inc}
{$undef FUNCTIONS}

{$define EXTERNAL_SYMBOLS}
{$include ./gdallib.inc}
{$undef EXTERNAL_SYMBOLS}

{$undef INTERFACE}

implementation
end.
