{ Parsed from GDAL.framework gdal.h }

{$ifndef GDAL_H_INCLUDED}

{$ifdef TYPES}
const
  GDT_Unknown = 0;
  GDT_Byte = 1;
  GDT_UInt16 = 2;
  GDT_Int16 = 3;
  GDT_UInt32 = 4;
  GDT_Int32 = 5;
  GDT_Float32 = 6;
  GDT_Float64 = 7;
  GDT_CInt16 = 8;
  GDT_CInt32 = 9;
  GDT_CFloat32 = 10;
  GDT_CFloat64 = 11;
  GDT_TypeCount = 12;
type
  GDALDataType = clong;
{$endif}

{$ifdef FUNCTIONS}
function GDALGetDataTypeSize(param1: GDALDataType): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDataTypeSize@4'{$ENDIF};
function GDALDataTypeIsComplex(param1: GDALDataType): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDataTypeIsComplex@4'{$ENDIF};
function GDALGetDataTypeName(param1: GDALDataType): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDataTypeName@4'{$ENDIF};
function GDALGetDataTypeByName(param1: charPtr): GDALDataType; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDataTypeByName@4'{$ENDIF};
function GDALDataTypeUnion(param1: GDALDataType; param2: GDALDataType): GDALDataType; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDataTypeUnion@8'{$ENDIF};
{$endif}

{$ifdef TYPES}
const
  GARIO_PENDING = 0;
  GARIO_UPDATE = 1;
  GARIO_ERROR = 2;
  GARIO_COMPLETE = 3;
  GARIO_TypeCount = 4;
type
  GDALAsyncStatusType = clong;
{$endif}

{$ifdef FUNCTIONS}
function GDALGetAsyncStatusTypeName(param1: GDALAsyncStatusType): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetAsyncStatusTypeName@4'{$ENDIF};
function GDALGetAsyncStatusTypeByName(param1: charPtr): GDALAsyncStatusType; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetAsyncStatusTypeByName@4'{$ENDIF};
{$endif}

{$ifdef TYPES}
const
  GA_ReadOnly = 0;
  GA_Update = 1;
type
  GDALAccess = clong;
const
  GF_Read = 0;
  GF_Write = 1;
type
  GDALRWFlag = clong;
const
  GCI_Undefined = 0;
  GCI_GrayIndex = 1;
  GCI_PaletteIndex = 2;
  GCI_RedBand = 3;
  GCI_GreenBand = 4;
  GCI_BlueBand = 5;
  GCI_AlphaBand = 6;
  GCI_HueBand = 7;
  GCI_SaturationBand = 8;
  GCI_LightnessBand = 9;
  GCI_CyanBand = 10;
  GCI_MagentaBand = 11;
  GCI_YellowBand = 12;
  GCI_BlackBand = 13;
  GCI_YCbCr_YBand = 14;
  GCI_YCbCr_CbBand = 15;
  GCI_YCbCr_CrBand = 16;
  GCI_Max = 16;
type
  GDALColorInterp = clong;
{$endif}

{$ifdef FUNCTIONS}
function GDALGetColorInterpretationName(param1: GDALColorInterp): charPtr; cdecl; external gdallib;
function GDALGetColorInterpretationByName(pszName: charPtr): GDALColorInterp; cdecl; external gdallib;
{$endif}

{$ifdef TYPES}
const
  GPI_Gray = 0;
  GPI_RGB = 1;
  GPI_CMYK = 2;
  GPI_HLS = 3;
type
  GDALPaletteInterp = clong;
{$endif}

{$ifdef FUNCTIONS}
function GDALGetPaletteInterpretationName(param1: GDALPaletteInterp): charPtr; cdecl; external gdallib;
{$endif}

{$ifdef TYPES}
const
  GDALMD_AREA_OR_POINT = 'AREA_OR_POINT';
  GDALMD_AOP_AREA = 'Area';
  GDALMD_AOP_POINT = 'Point';
  CPLE_WrongFormat = 200;

type
  GDALMajorObjectH = ^pointer;
  GDALDatasetH = ^pointer;
  GDALRasterBandH = ^pointer;
  GDALDriverH = ^pointer;
{$endif}

{$ifndef DOXYGEN_SKIP}
{$ifdef TYPES}
type
  GDALProjDefH = ^pointer;
{$endif}

{$endif}
{$ifdef TYPES}
type
  GDALColorTableH = ^pointer;
  GDALRasterAttributeTableH = ^pointer;
  GDALAsyncReaderH = ^pointer;
{$endif}

{$ifndef DOXYGEN_SKIP}
{$ifdef TYPES}
type
  GDALOptionDefinition = record
    pszOptionName: charPtr;
    pszValueType: charPtr;
    pszDescription: charPtr;
    papszOptions: charPtrPtr;
  end;
type
  GDALOptionDefinitionPtr = ^GDALOptionDefinition;
{$endif}

{$endif}
{$ifdef TYPES}
const
  GDAL_DMD_LONGNAME = 'DMD_LONGNAME';
  GDAL_DMD_HELPTOPIC = 'DMD_HELPTOPIC';
  GDAL_DMD_MIMETYPE = 'DMD_MIMETYPE';
  GDAL_DMD_EXTENSION = 'DMD_EXTENSION';
  GDAL_DMD_CREATIONOPTIONLIST = 'DMD_CREATIONOPTIONLIST';
  GDAL_DMD_CREATIONDATATYPES = 'DMD_CREATIONDATATYPES';
  GDAL_DMD_SUBDATASETS = 'DMD_SUBDATASETS';
  GDAL_DCAP_CREATE = 'DCAP_CREATE';
  GDAL_DCAP_CREATECOPY = 'DCAP_CREATECOPY';
  GDAL_DCAP_VIRTUALIO = 'DCAP_VIRTUALIO';
{$endif}

{$ifdef FUNCTIONS}
procedure GDALAllRegister; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALAllRegister@0'{$ENDIF};
function GDALCreate(hDriver: GDALDriverH; param2: charPtr; param3: cint; param4: cint; param5: cint; param6: GDALDataType; param7: charPtrPtr): GDALDatasetH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCreate@28'{$ENDIF};
function GDALCreateCopy(param1: GDALDriverH; param2: charPtr; param3: GDALDatasetH; param4: cint; param5: charPtrPtr; param6: GDALProgressFunc; param7: pointer): GDALDatasetH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCreateCopy@28'{$ENDIF};
function GDALIdentifyDriver(pszFilename: charPtr; papszFileList: charPtrPtr): GDALDriverH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALIdentifyDriver@8'{$ENDIF};
function GDALOpen(pszFilename: charPtr; eAccess: GDALAccess): GDALDatasetH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALOpen@8'{$ENDIF};
function GDALOpenShared(param1: charPtr; param2: GDALAccess): GDALDatasetH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALOpenShared@8'{$ENDIF};
function GDALDumpOpenDatasets(param1: FILEPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDumpOpenDatasets@4'{$ENDIF};
function GDALGetDriverByName(param1: charPtr): GDALDriverH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDriverByName@4'{$ENDIF};
function GDALGetDriverCount: cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDriverCount@0'{$ENDIF};
function GDALGetDriver(param1: cint): GDALDriverH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDriver@4'{$ENDIF};
procedure GDALDestroyDriver(param1: GDALDriverH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDestroyDriver@4'{$ENDIF};
function GDALRegisterDriver(param1: GDALDriverH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRegisterDriver@4'{$ENDIF};
procedure GDALDeregisterDriver(param1: GDALDriverH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDeregisterDriver@4'{$ENDIF};
procedure GDALDestroyDriverManager; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDestroyDriverManager@0'{$ENDIF};
function GDALDeleteDataset(param1: GDALDriverH; param2: charPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDeleteDataset@8'{$ENDIF};
function GDALRenameDataset(param1: GDALDriverH; pszNewName: charPtr; pszOldName: charPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRenameDataset@12'{$ENDIF};
function GDALCopyDatasetFiles(param1: GDALDriverH; pszNewName: charPtr; pszOldName: charPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCopyDatasetFiles@12'{$ENDIF};
function GDALValidateCreationOptions(param1: GDALDriverH; papszCreationOptions: charPtrPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALValidateCreationOptions@8'{$ENDIF};
function GDALGetDriverShortName(param1: GDALDriverH): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDriverShortName@4'{$ENDIF};
function GDALGetDriverLongName(param1: GDALDriverH): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDriverLongName@4'{$ENDIF};
function GDALGetDriverHelpTopic(param1: GDALDriverH): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDriverHelpTopic@4'{$ENDIF};
function GDALGetDriverCreationOptionList(param1: GDALDriverH): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDriverCreationOptionList@4'{$ENDIF};
{$endif}

{$ifdef TYPES}
type
  GDAL_GCP = record
    pszId: charPtr;
    pszInfo: charPtr;
    dfGCPPixel: double;
    dfGCPLine: double;
    dfGCPX: double;
    dfGCPY: double;
    dfGCPZ: double;
  end;
type
  GDAL_GCPPtr = ^GDAL_GCP;
{$endif}

{$ifdef FUNCTIONS}
procedure GDALInitGCPs(param1: cint; param2: GDAL_GCPPtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALInitGCPs@8'{$ENDIF};
procedure GDALDeinitGCPs(param1: cint; param2: GDAL_GCPPtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDeinitGCPs@8'{$ENDIF};
function GDALDuplicateGCPs(param1: cint; param2: GDAL_GCPPtr): GDAL_GCPPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDuplicateGCPs@8'{$ENDIF};
function GDALGCPsToGeoTransform(nGCPCount: cint; pasGCPs: GDAL_GCPPtr; padfGeoTransform: doublePtr; bApproxOK: cint): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGCPsToGeoTransform@16'{$ENDIF};
function GDALInvGeoTransform(padfGeoTransformIn: doublePtr; padfInvGeoTransformOut: doublePtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALInvGeoTransform@8'{$ENDIF};
procedure GDALApplyGeoTransform(param1: doublePtr; param2: double; param3: double; param4: doublePtr; param5: doublePtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALApplyGeoTransform@28'{$ENDIF};
procedure GDALComposeGeoTransforms(padfGeoTransform1: doublePtr; padfGeoTransform2: doublePtr; padfGeoTransformOut: doublePtr); cdecl; external gdallib;
function GDALGetMetadataDomainList(hObject: GDALMajorObjectH): charPtrPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetMetadataDomainList@4'{$ENDIF};
function GDALGetMetadata(param1: GDALMajorObjectH; param2: charPtr): charPtrPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetMetadata@8'{$ENDIF};
function GDALSetMetadata(param1: GDALMajorObjectH; param2: charPtrPtr; param3: charPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetMetadata@12'{$ENDIF};
function GDALGetMetadataItem(param1: GDALMajorObjectH; param2: charPtr; param3: charPtr): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetMetadataItem@12'{$ENDIF};
function GDALSetMetadataItem(param1: GDALMajorObjectH; param2: charPtr; param3: charPtr; param4: charPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetMetadataItem@16'{$ENDIF};
function GDALGetDescription(param1: GDALMajorObjectH): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDescription@4'{$ENDIF};
procedure GDALSetDescription(param1: GDALMajorObjectH; param2: charPtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetDescription@8'{$ENDIF};
function GDALGetDatasetDriver(param1: GDALDatasetH): GDALDriverH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDatasetDriver@4'{$ENDIF};
function GDALGetFileList(param1: GDALDatasetH): charPtrPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetFileList@4'{$ENDIF};
procedure GDALClose(param1: GDALDatasetH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALClose@4'{$ENDIF};
function GDALGetRasterXSize(param1: GDALDatasetH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterXSize@4'{$ENDIF};
function GDALGetRasterYSize(param1: GDALDatasetH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterYSize@4'{$ENDIF};
function GDALGetRasterCount(param1: GDALDatasetH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterCount@4'{$ENDIF};
function GDALGetRasterBand(param1: GDALDatasetH; param2: cint): GDALRasterBandH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterBand@8'{$ENDIF};
function GDALAddBand(hDS: GDALDatasetH; eType: GDALDataType; papszOptions: charPtrPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALAddBand@12'{$ENDIF};
function GDALBeginAsyncReader(hDS: GDALDatasetH; nXOff: cint; nYOff: cint; nXSize: cint; nYSize: cint; pBuf: pointer; nBufXSize: cint; nBufYSize: cint; eBufType: GDALDataType; nBandCount: cint; panBandMap: cintPtr; nPixelSpace: cint; nLineSpace: cint; nBandSpace: cint; papszOptions: charPtrPtr): GDALAsyncReaderH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALBeginAsyncReader@60'{$ENDIF};
procedure GDALEndAsyncReader(hDS: GDALDatasetH; hAsynchReaderH: GDALAsyncReaderH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALEndAsyncReader@8'{$ENDIF};
function GDALDatasetRasterIO(hDS: GDALDatasetH; eRWFlag: GDALRWFlag; nDSXOff: cint; nDSYOff: cint; nDSXSize: cint; nDSYSize: cint; pBuffer: pointer; nBXSize: cint; nBYSize: cint; eBDataType: GDALDataType; nBandCount: cint; panBandCount: cintPtr; nPixelSpace: cint; nLineSpace: cint; nBandSpace: cint): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDatasetRasterIO@60'{$ENDIF};
function GDALDatasetAdviseRead(hDS: GDALDatasetH; nDSXOff: cint; nDSYOff: cint; nDSXSize: cint; nDSYSize: cint; nBXSize: cint; nBYSize: cint; eBDataType: GDALDataType; nBandCount: cint; panBandCount: cintPtr; papszOptions: charPtrPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDatasetAdviseRead@44'{$ENDIF};
function GDALGetProjectionRef(param1: GDALDatasetH): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetProjectionRef@4'{$ENDIF};
function GDALSetProjection(param1: GDALDatasetH; param2: charPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetProjection@8'{$ENDIF};
function GDALGetGeoTransform(param1: GDALDatasetH; param2: doublePtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetGeoTransform@8'{$ENDIF};
function GDALSetGeoTransform(param1: GDALDatasetH; param2: doublePtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetGeoTransform@8'{$ENDIF};
function GDALGetGCPCount(param1: GDALDatasetH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetGCPCount@4'{$ENDIF};
function GDALGetGCPProjection(param1: GDALDatasetH): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetGCPProjection@4'{$ENDIF};
function GDALGetGCPs(param1: GDALDatasetH): GDAL_GCPPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetGCPs@4'{$ENDIF};
function GDALSetGCPs(param1: GDALDatasetH; param2: cint; param3: GDAL_GCPPtr; param4: charPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetGCPs@16'{$ENDIF};
function GDALGetInternalHandle(param1: GDALDatasetH; param2: charPtr): pointer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetInternalHandle@8'{$ENDIF};
function GDALReferenceDataset(param1: GDALDatasetH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALReferenceDataset@4'{$ENDIF};
function GDALDereferenceDataset(param1: GDALDatasetH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDereferenceDataset@4'{$ENDIF};
function GDALBuildOverviews(param1: GDALDatasetH; param2: charPtr; param3: cint; param4: cintPtr; param5: cint; param6: cintPtr; param7: GDALProgressFunc; param8: pointer): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALBuildOverviews@32'{$ENDIF};
procedure GDALGetOpenDatasets(hDS: GDALDatasetHPtr; pnCount: cintPtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetOpenDatasets@8'{$ENDIF};
function GDALGetAccess(hDS: GDALDatasetH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetAccess@4'{$ENDIF};
procedure GDALFlushCache(hDS: GDALDatasetH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALFlushCache@4'{$ENDIF};
function GDALCreateDatasetMaskBand(hDS: GDALDatasetH; nFlags: cint): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCreateDatasetMaskBand@8'{$ENDIF};
function GDALDatasetCopyWholeRaster(hSrcDS: GDALDatasetH; hDstDS: GDALDatasetH; papszOptions: charPtrPtr; pfnProgress: GDALProgressFunc; pProgressData: pointer): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDatasetCopyWholeRaster@20'{$ENDIF};
function GDALRasterBandCopyWholeRaster(hSrcBand: GDALRasterBandH; hDstBand: GDALRasterBandH; papszOptions: charPtrPtr; pfnProgress: GDALProgressFunc; pProgressData: pointer): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRasterBandCopyWholeRaster@20'{$ENDIF};
function GDALRegenerateOverviews(hSrcBand: GDALRasterBandH; nOverviewCount: cint; pahOverviewBands: GDALRasterBandH; pszResampling: charPtr; pfnProgress: GDALProgressFunc; pProgressData: pointer): CPLErr; cdecl; external gdallib;
{$endif}

{$ifdef TYPES}
type
  GDALDerivedPixelFunc = function (papoSources: pointerPtr; nSources: cint; pData: pointer; nBufXSize: cint; nBufYSize: cint; eSrcType: GDALDataType; eBufType: GDALDataType; nPixelSpace: cint; nLineSpace: cint): CPLErr; cdecl;
{$endif}

{$ifdef FUNCTIONS}
function GDALGetRasterDataType(param1: GDALRasterBandH): GDALDataType; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterDataType@4'{$ENDIF};
procedure GDALGetBlockSize(param1: GDALRasterBandH; pnXSize: cintPtr; pnYSize: cintPtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetBlockSize@12'{$ENDIF};
function GDALRasterAdviseRead(hRB: GDALRasterBandH; nDSXOff: cint; nDSYOff: cint; nDSXSize: cint; nDSYSize: cint; nBXSize: cint; nBYSize: cint; eBDataType: GDALDataType; papszOptions: charPtrPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRasterAdviseRead@36'{$ENDIF};
function GDALRasterIO(hRBand: GDALRasterBandH; eRWFlag: GDALRWFlag; nDSXOff: cint; nDSYOff: cint; nDSXSize: cint; nDSYSize: cint; pBuffer: pointer; nBXSize: cint; nBYSize: cint; eBDataType: GDALDataType; nPixelSpace: cint; nLineSpace: cint): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRasterIO@48'{$ENDIF};
function GDALReadBlock(param1: GDALRasterBandH; param2: cint; param3: cint; param4: pointer): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALReadBlock@16'{$ENDIF};
function GDALWriteBlock(param1: GDALRasterBandH; param2: cint; param3: cint; param4: pointer): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALWriteBlock@16'{$ENDIF};
function GDALGetRasterBandXSize(param1: GDALRasterBandH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterBandXSize@4'{$ENDIF};
function GDALGetRasterBandYSize(param1: GDALRasterBandH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterBandYSize@4'{$ENDIF};
function GDALGetRasterAccess(param1: GDALRasterBandH): GDALAccess; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterAccess@4'{$ENDIF};
function GDALGetBandNumber(param1: GDALRasterBandH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetBandNumber@4'{$ENDIF};
function GDALGetBandDataset(param1: GDALRasterBandH): GDALDatasetH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetBandDataset@4'{$ENDIF};
function GDALGetRasterColorInterpretation(param1: GDALRasterBandH): GDALColorInterp; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterColorInterpretation@4'{$ENDIF};
function GDALSetRasterColorInterpretation(param1: GDALRasterBandH; param2: GDALColorInterp): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetRasterColorInterpretation@8'{$ENDIF};
function GDALGetRasterColorTable(param1: GDALRasterBandH): GDALColorTableH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterColorTable@4'{$ENDIF};
function GDALSetRasterColorTable(param1: GDALRasterBandH; param2: GDALColorTableH): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetRasterColorTable@8'{$ENDIF};
function GDALHasArbitraryOverviews(param1: GDALRasterBandH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALHasArbitraryOverviews@4'{$ENDIF};
function GDALGetOverviewCount(param1: GDALRasterBandH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetOverviewCount@4'{$ENDIF};
function GDALGetOverview(param1: GDALRasterBandH; param2: cint): GDALRasterBandH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetOverview@8'{$ENDIF};
function GDALGetRasterNoDataValue(param1: GDALRasterBandH; param2: cintPtr): double; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterNoDataValue@8'{$ENDIF};
function GDALSetRasterNoDataValue(param1: GDALRasterBandH; param2: double): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetRasterNoDataValue@12'{$ENDIF};
function GDALGetRasterCategoryNames(param1: GDALRasterBandH): charPtrPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterCategoryNames@4'{$ENDIF};
function GDALSetRasterCategoryNames(param1: GDALRasterBandH; param2: charPtrPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetRasterCategoryNames@8'{$ENDIF};
function GDALGetRasterMinimum(param1: GDALRasterBandH; pbSuccess: cintPtr): double; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterMinimum@8'{$ENDIF};
function GDALGetRasterMaximum(param1: GDALRasterBandH; pbSuccess: cintPtr): double; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterMaximum@8'{$ENDIF};
function GDALGetRasterStatistics(param1: GDALRasterBandH; bApproxOK: cint; bForce: cint; pdfMin: doublePtr; pdfMax: doublePtr; pdfMean: doublePtr; pdfStdDev: doublePtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterStatistics@28'{$ENDIF};
function GDALComputeRasterStatistics(param1: GDALRasterBandH; bApproxOK: cint; pdfMin: doublePtr; pdfMax: doublePtr; pdfMean: doublePtr; pdfStdDev: doublePtr; pfnProgress: GDALProgressFunc; pProgressData: pointer): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALComputeRasterStatistics@32'{$ENDIF};
function GDALSetRasterStatistics(hBand: GDALRasterBandH; dfMin: double; dfMax: double; dfMean: double; dfStdDev: double): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetRasterStatistics@36'{$ENDIF};
function GDALGetRasterUnitType(param1: GDALRasterBandH): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterUnitType@4'{$ENDIF};
function GDALSetRasterUnitType(hBand: GDALRasterBandH; pszNewValue: charPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetRasterUnitType@8'{$ENDIF};
function GDALGetRasterOffset(param1: GDALRasterBandH; pbSuccess: cintPtr): double; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterOffset@8'{$ENDIF};
function GDALSetRasterOffset(hBand: GDALRasterBandH; dfNewOffset: double): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetRasterOffset@12'{$ENDIF};
function GDALGetRasterScale(param1: GDALRasterBandH; pbSuccess: cintPtr): double; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterScale@8'{$ENDIF};
function GDALSetRasterScale(hBand: GDALRasterBandH; dfNewOffset: double): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetRasterScale@12'{$ENDIF};
procedure GDALComputeRasterMinMax(hBand: GDALRasterBandH; bApproxOK: cint; adfMinMax: doublePtr { 2 element array of double }); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALComputeRasterMinMax@12'{$ENDIF};
function GDALFlushRasterCache(hBand: GDALRasterBandH): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALFlushRasterCache@4'{$ENDIF};
function GDALGetRasterHistogram(hBand: GDALRasterBandH; dfMin: double; dfMax: double; nBuckets: cint; panHistogram: cintPtr; bIncludeOutOfRange: cint; bApproxOK: cint; pfnProgress: GDALProgressFunc; pProgressData: pointer): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterHistogram@44'{$ENDIF};
function GDALGetDefaultHistogram(hBand: GDALRasterBandH; pdfMin: doublePtr; pdfMax: doublePtr; pnBuckets: cintPtr; ppanHistogram: cintPtrPtr; bForce: cint; pfnProgress: GDALProgressFunc; pProgressData: pointer): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDefaultHistogram@32'{$ENDIF};
function GDALSetDefaultHistogram(hBand: GDALRasterBandH; dfMin: double; dfMax: double; nBuckets: cint; panHistogram: cintPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetDefaultHistogram@28'{$ENDIF};
function GDALGetRandomRasterSample(param1: GDALRasterBandH; param2: cint; param3: floatPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRandomRasterSample@12'{$ENDIF};
function GDALGetRasterSampleOverview(param1: GDALRasterBandH; param2: cint): GDALRasterBandH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetRasterSampleOverview@8'{$ENDIF};
function GDALFillRaster(hBand: GDALRasterBandH; dfRealValue: double; dfImaginaryValue: double): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALFillRaster@20'{$ENDIF};
function GDALComputeBandStats(hBand: GDALRasterBandH; nSampleStep: cint; pdfMean: doublePtr; pdfStdDev: doublePtr; pfnProgress: GDALProgressFunc; pProgressData: pointer): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALComputeBandStats@24'{$ENDIF};
function GDALOverviewMagnitudeCorrection(hBaseBand: GDALRasterBandH; nOverviewCount: cint; pahOverviews: GDALRasterBandH; pfnProgress: GDALProgressFunc; pProgressData: pointer): CPLErr; cdecl; external gdallib;
function GDALGetDefaultRAT(hBand: GDALRasterBandH): GDALRasterAttributeTableH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetDefaultRAT@4'{$ENDIF};
function GDALSetDefaultRAT(param1: GDALRasterBandH; param2: GDALRasterAttributeTableH): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetDefaultRAT@8'{$ENDIF};
function GDALAddDerivedBandPixelFunc(pszName: charPtr; pfnPixelFunc: GDALDerivedPixelFunc): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALAddDerivedBandPixelFunc@8'{$ENDIF};
function GDALGetMaskBand(hBand: GDALRasterBandH): GDALRasterBandH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetMaskBand@4'{$ENDIF};
function GDALGetMaskFlags(hBand: GDALRasterBandH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetMaskFlags@4'{$ENDIF};
function GDALCreateMaskBand(hBand: GDALRasterBandH; nFlags: cint): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCreateMaskBand@8'{$ENDIF};
{$endif}

{$ifdef TYPES}
const
  GMF_ALL_VALID = $01;
  GMF_PER_DATASET = $02;
  GMF_ALPHA = $04;
  GMF_NODATA = $08;
{$endif}

{$ifdef FUNCTIONS}
function GDALARGetNextUpdatedRegion(hARIO: GDALAsyncReaderH; dfTimeout: double; pnXBufOff: cintPtr; pnYBufOff: cintPtr; pnXBufSize: cintPtr; pnYBufSize: cintPtr): GDALAsyncStatusType; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALARGetNextUpdatedRegion@28'{$ENDIF};
function GDALARLockBuffer(hARIO: GDALAsyncReaderH; dfTimeout: double): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALARLockBuffer@12'{$ENDIF};
procedure GDALARUnlockBuffer(hARIO: GDALAsyncReaderH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALARUnlockBuffer@4'{$ENDIF};
function GDALGeneralCmdLineProcessor(nArgc: cint; ppapszArgv: charPtrPtrPtr; nOptions: cint): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGeneralCmdLineProcessor@12'{$ENDIF};
procedure GDALSwapWords(pData: pointer; nWordSize: cint; nWordCount: cint; nWordSkip: cint); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSwapWords@16'{$ENDIF};
procedure GDALCopyWords(pSrcData: pointer; eSrcType: GDALDataType; nSrcPixelOffset: cint; pDstData: pointer; eDstType: GDALDataType; nDstPixelOffset: cint; nWordCount: cint); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCopyWords@28'{$ENDIF};
procedure GDALCopyBits(pabySrcData: GBytePtr; nSrcOffset: cint; nSrcStep: cint; pabyDstData: GBytePtr; nDstOffset: cint; nDstStep: cint; nBitCount: cint; nStepCount: cint); cdecl; external gdallib;
function GDALLoadWorldFile(param1: charPtr; param2: doublePtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALLoadWorldFile@8'{$ENDIF};
function GDALReadWorldFile(param1: charPtr; param2: charPtr; param3: doublePtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALReadWorldFile@12'{$ENDIF};
function GDALWriteWorldFile(param1: charPtr; param2: charPtr; param3: doublePtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALWriteWorldFile@12'{$ENDIF};
function GDALLoadTabFile(param1: charPtr; param2: doublePtr; param3: charPtrPtr; param4: cintPtr; param5: GDAL_GCPPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALLoadTabFile@20'{$ENDIF};
function GDALReadTabFile(param1: charPtr; param2: doublePtr; param3: charPtrPtr; param4: cintPtr; param5: GDAL_GCPPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALReadTabFile@20'{$ENDIF};
function GDALLoadOziMapFile(param1: charPtr; param2: doublePtr; param3: charPtrPtr; param4: cintPtr; param5: GDAL_GCPPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALLoadOziMapFile@20'{$ENDIF};
function GDALReadOziMapFile(param1: charPtr; param2: doublePtr; param3: charPtrPtr; param4: cintPtr; param5: GDAL_GCPPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALReadOziMapFile@20'{$ENDIF};
function GDALLoadRPBFile(pszFilename: charPtr; papszSiblingFiles: charPtrPtr): charPtrPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALLoadRPBFile@8'{$ENDIF};
function GDALLoadRPCFile(pszFilename: charPtr; papszSiblingFiles: charPtrPtr): charPtrPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALLoadRPCFile@8'{$ENDIF};
function GDALWriteRPBFile(pszFilename: charPtr; papszMD: charPtrPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALWriteRPBFile@8'{$ENDIF};
function GDALLoadIMDFile(pszFilename: charPtr; papszSiblingFiles: charPtrPtr): charPtrPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALLoadIMDFile@8'{$ENDIF};
function GDALWriteIMDFile(pszFilename: charPtr; papszMD: charPtrPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALWriteIMDFile@8'{$ENDIF};
function GDALDecToDMS(param1: double; param2: charPtr; param3: cint): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDecToDMS@16'{$ENDIF};
function GDALPackedDMSToDec(param1: double): double; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALPackedDMSToDec@8'{$ENDIF};
function GDALDecToPackedDMS(param1: double): double; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDecToPackedDMS@8'{$ENDIF};
{$endif}

{$ifndef GDAL_VERSION_INFO_DEFINED}
{$ifdef FUNCTIONS}
function GDALVersionInfo(param1: charPtr): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALVersionInfo@4'{$ENDIF};
{$endif}

{$endif}

{$ifndef GDAL_CHECK_VERSION}
{$ifdef FUNCTIONS}
function GDALCheckVersion(nVersionMajor: cint; nVersionMinor: cint; pszCallingComponentName: charPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCheckVersion@12'{$ENDIF};
{$endif}

{$endif}
{$ifdef TYPES}
type
  GDALRPCInfo = record
    dfLINE_OFF: double;
    dfSAMP_OFF: double;
    dfLAT_OFF: double;
    dfLONG_OFF: double;
    dfHEIGHT_OFF: double;
    dfLINE_SCALE: double;
    dfSAMP_SCALE: double;
    dfLAT_SCALE: double;
    dfLONG_SCALE: double;
    dfHEIGHT_SCALE: double;
    adfLINE_NUM_COEFF:array[0..19] of double;
    adfLINE_DEN_COEFF:array[0..19] of double;
    adfSAMP_NUM_COEFF:array[0..19] of double;
    adfSAMP_DEN_COEFF:array[0..19] of double;
    dfMIN_LONG: double;
    dfMIN_LAT: double;
    dfMAX_LONG: double;
    dfMAX_LAT: double;
  end;
type
  GDALRPCInfoPtr = ^GDALRPCInfo;
{$endif}

{$ifdef FUNCTIONS}
function GDALExtractRPCInfo(param1: charPtrPtr; param2: GDALRPCInfoPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALExtractRPCInfo@8'{$ENDIF};
{$endif}

{$ifdef TYPES}
type
  GDALColorEntry = record
    c1: cshort;
    c2: cshort;
    c3: cshort;
    c4: cshort;
  end;
type
  GDALColorEntryPtr = ^GDALColorEntry;
{$endif}

{$ifdef FUNCTIONS}
function GDALCreateColorTable(param1: GDALPaletteInterp): GDALColorTableH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCreateColorTable@4'{$ENDIF};
procedure GDALDestroyColorTable(param1: GDALColorTableH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDestroyColorTable@4'{$ENDIF};
function GDALCloneColorTable(param1: GDALColorTableH): GDALColorTableH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCloneColorTable@4'{$ENDIF};
function GDALGetPaletteInterpretation(param1: GDALColorTableH): GDALPaletteInterp; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetPaletteInterpretation@4'{$ENDIF};
function GDALGetColorEntryCount(param1: GDALColorTableH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetColorEntryCount@4'{$ENDIF};
function GDALGetColorEntry(param1: GDALColorTableH; param2: cint): GDALColorEntryPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetColorEntry@8'{$ENDIF};
function GDALGetColorEntryAsRGB(param1: GDALColorTableH; param2: cint; param3: GDALColorEntryPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetColorEntryAsRGB@12'{$ENDIF};
procedure GDALSetColorEntry(param1: GDALColorTableH; param2: cint; param3: GDALColorEntryPtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetColorEntry@12'{$ENDIF};
procedure GDALCreateColorRamp(hTable: GDALColorTableH; nStartIndex: cint; psStartColor: GDALColorEntryPtr; nEndIndex: cint; psEndColor: GDALColorEntryPtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCreateColorRamp@20'{$ENDIF};
{$endif}

{$ifdef TYPES}
const
  GFT_Integer = 0;
  GFT_Real = 1;
  GFT_String = 2;
type
  GDALRATFieldType = clong;
const
  GFU_Generic = 0;
  GFU_PixelCount = 1;
  GFU_Name = 2;
  GFU_Min = 3;
  GFU_Max = 4;
  GFU_MinMax = 5;
  GFU_Red = 6;
  GFU_Green = 7;
  GFU_Blue = 8;
  GFU_Alpha = 9;
  GFU_RedMin = 10;
  GFU_GreenMin = 11;
  GFU_BlueMin = 12;
  GFU_AlphaMin = 13;
  GFU_RedMax = 14;
  GFU_GreenMax = 15;
  GFU_BlueMax = 16;
  GFU_AlphaMax = 17;
  GFU_MaxCount = 18;
type
  GDALRATFieldUsage = clong;
{$endif}

{$ifdef FUNCTIONS}
function GDALCreateRasterAttributeTable: GDALRasterAttributeTableH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALCreateRasterAttributeTable@0'{$ENDIF};
procedure GDALDestroyRasterAttributeTable(param1: GDALRasterAttributeTableH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALDestroyRasterAttributeTable@4'{$ENDIF};
function GDALRATGetColumnCount(param1: GDALRasterAttributeTableH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetColumnCount@4'{$ENDIF};
function GDALRATGetNameOfCol(param1: GDALRasterAttributeTableH; param2: cint): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetNameOfCol@8'{$ENDIF};
function GDALRATGetUsageOfCol(param1: GDALRasterAttributeTableH; param2: cint): GDALRATFieldUsage; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetUsageOfCol@8'{$ENDIF};
function GDALRATGetTypeOfCol(param1: GDALRasterAttributeTableH; param2: cint): GDALRATFieldType; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetTypeOfCol@8'{$ENDIF};
function GDALRATGetColOfUsage(param1: GDALRasterAttributeTableH; param2: GDALRATFieldUsage): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetColOfUsage@8'{$ENDIF};
function GDALRATGetRowCount(param1: GDALRasterAttributeTableH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetRowCount@4'{$ENDIF};
function GDALRATGetValueAsString(param1: GDALRasterAttributeTableH; param2: cint; param3: cint): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetValueAsString@12'{$ENDIF};
function GDALRATGetValueAsInt(param1: GDALRasterAttributeTableH; param2: cint; param3: cint): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetValueAsInt@12'{$ENDIF};
function GDALRATGetValueAsDouble(param1: GDALRasterAttributeTableH; param2: cint; param3: cint): double; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetValueAsDouble@12'{$ENDIF};
procedure GDALRATSetValueAsString(param1: GDALRasterAttributeTableH; param2: cint; param3: cint; param4: charPtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATSetValueAsString@16'{$ENDIF};
procedure GDALRATSetValueAsInt(param1: GDALRasterAttributeTableH; param2: cint; param3: cint; param4: cint); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATSetValueAsInt@16'{$ENDIF};
procedure GDALRATSetValueAsDouble(param1: GDALRasterAttributeTableH; param2: cint; param3: cint; param4: double); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATSetValueAsDouble@20'{$ENDIF};
function GDALRATChangesAreWrittenToFile(hRAT: GDALRasterAttributeTableH): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATChangesAreWrittenToFile@4'{$ENDIF};
function GDALRATValuesIOAsDouble(hRAT: GDALRasterAttributeTableH; eRWFlag: GDALRWFlag; iField: cint; iStartRow: cint; iLength: cint; pdfData: doublePtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATValuesIOAsDouble@24'{$ENDIF};
function GDALRATValuesIOAsInteger(hRAT: GDALRasterAttributeTableH; eRWFlag: GDALRWFlag; iField: cint; iStartRow: cint; iLength: cint; pnData: cintPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATValuesIOAsInteger@24'{$ENDIF};
function GDALRATValuesIOAsString(hRAT: GDALRasterAttributeTableH; eRWFlag: GDALRWFlag; iField: cint; iStartRow: cint; iLength: cint; papszStrList: charPtrPtr): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATValuesIOAsString@24'{$ENDIF};
procedure GDALRATSetRowCount(param1: GDALRasterAttributeTableH; param2: cint); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATSetRowCount@8'{$ENDIF};
function GDALRATCreateColumn(param1: GDALRasterAttributeTableH; param2: charPtr; param3: GDALRATFieldType; param4: GDALRATFieldUsage): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATCreateColumn@16'{$ENDIF};
function GDALRATSetLinearBinning(param1: GDALRasterAttributeTableH; param2: double; param3: double): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATSetLinearBinning@20'{$ENDIF};
function GDALRATGetLinearBinning(param1: GDALRasterAttributeTableH; param2: doublePtr; param3: doublePtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetLinearBinning@12'{$ENDIF};
function GDALRATInitializeFromColorTable(param1: GDALRasterAttributeTableH; param2: GDALColorTableH): CPLErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATInitializeFromColorTable@8'{$ENDIF};
function GDALRATTranslateToColorTable(param1: GDALRasterAttributeTableH; nEntryCount: cint): GDALColorTableH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATTranslateToColorTable@8'{$ENDIF};
procedure GDALRATDumpReadable(param1: GDALRasterAttributeTableH; param2: FILEPtr); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATDumpReadable@8'{$ENDIF};
function GDALRATClone(param1: GDALRasterAttributeTableH): GDALRasterAttributeTableH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATClone@4'{$ENDIF};
function GDALRATGetRowOfValue(param1: GDALRasterAttributeTableH; param2: double): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALRATGetRowOfValue@12'{$ENDIF};
procedure GDALSetCacheMax(nBytes: cint); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetCacheMax@4'{$ENDIF};
function GDALGetCacheMax: cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetCacheMax@0'{$ENDIF};
function GDALGetCacheUsed: cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetCacheUsed@0'{$ENDIF};
procedure GDALSetCacheMax64(nBytes: GIntBig); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALSetCacheMax64@8'{$ENDIF};
function GDALGetCacheMax64: GIntBig; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetCacheMax64@0'{$ENDIF};
function GDALGetCacheUsed64: GIntBig; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALGetCacheUsed64@0'{$ENDIF};
function GDALFlushCacheBlock: cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_GDALFlushCacheBlock@0'{$ENDIF};
function GDALDatasetGetVirtualMem(hDS: GDALDatasetH; eRWFlag: GDALRWFlag; nXOff: cint; nYOff: cint; nXSize: cint; nYSize: cint; nBufXSize: cint; nBufYSize: cint; eBufType: GDALDataType; nBandCount: cint; panBandMap: cintPtr; nPixelSpace: cint; nLineSpace: GIntBig; nBandSpace: GIntBig; nCacheSize: csize_t; nPageSizeHint: csize_t; bSingleThreadUsage: cint; papszOptions: charPtrPtr): CPLVirtualMemPtr; cdecl; external gdallib;
function GDALRasterBandGetVirtualMem(hBand: GDALRasterBandH; eRWFlag: GDALRWFlag; nXOff: cint; nYOff: cint; nXSize: cint; nYSize: cint; nBufXSize: cint; nBufYSize: cint; eBufType: GDALDataType; nPixelSpace: cint; nLineSpace: GIntBig; nCacheSize: csize_t; nPageSizeHint: csize_t; bSingleThreadUsage: cint; papszOptions: charPtrPtr): CPLVirtualMemPtr; cdecl; external gdallib;
function GDALGetVirtualMemAuto(hBand: GDALRasterBandH; eRWFlag: GDALRWFlag; pnPixelSpace: cintPtr; pnLineSpace: GIntBigPtr; papszOptions: charPtrPtr): CPLVirtualMemPtr; cdecl; external gdallib;
{$endif}

{$ifdef TYPES}
const
  GTO_TIP = 0;
  GTO_BIT = 1;
  GTO_BSQ = 2;
type
  GDALTileOrganization = clong;
{$endif}

{$ifdef FUNCTIONS}
function GDALDatasetGetTiledVirtualMem(hDS: GDALDatasetH; eRWFlag: GDALRWFlag; nXOff: cint; nYOff: cint; nXSize: cint; nYSize: cint; nTileXSize: cint; nTileYSize: cint; eBufType: GDALDataType; nBandCount: cint; panBandMap: cintPtr; eTileOrganization: GDALTileOrganization; nCacheSize: csize_t; bSingleThreadUsage: cint; papszOptions: charPtrPtr): CPLVirtualMemPtr; cdecl; external gdallib;
function GDALRasterBandGetTiledVirtualMem(hBand: GDALRasterBandH; eRWFlag: GDALRWFlag; nXOff: cint; nYOff: cint; nXSize: cint; nYSize: cint; nTileXSize: cint; nTileYSize: cint; eBufType: GDALDataType; nCacheSize: csize_t; bSingleThreadUsage: cint; papszOptions: charPtrPtr): CPLVirtualMemPtr; cdecl; external gdallib;
{$endif}

{$endif}
