{ Parsed from GDAL.framework ogr_core.h }

{$ifndef OGR_CORE_H_INCLUDED}

{$ifdef TYPES}
type
  OGREnvelope = record
    MinX: double;
    MaxX: double;
    MinY: double;
    MaxY: double;
  end;
type
  OGREnvelopePtr = ^OGREnvelope;
{$endif}

{$ifdef TYPES}
type
  OGREnvelope3D = record
    MinX: double;
    MaxX: double;
    MinY: double;
    MaxY: double;
    MinZ: double;
    MaxZ: double;
  end;
type
  OGREnvelope3DPtr = ^OGREnvelope3D;
{$endif}
{$ifdef FUNCTIONS}
function OGRMalloc(param1: csize_t): pointer; cdecl; external gdallib;
function OGRCalloc(param1: csize_t; param2: csize_t): pointer; cdecl; external gdallib;
function OGRRealloc(param1: pointer; param2: csize_t): pointer; cdecl; external gdallib;
function OGRStrdup(param1: charPtr): charPtr; cdecl; external gdallib;
procedure OGRFree(param1: pointer); cdecl; external gdallib;
{$endif}

{$ifdef TYPES}
type
  OGRErr = cint;
  OGRErrPtr = ^OGRErr;

const
  OGRERR_NONE = 0;
  OGRERR_NOT_ENOUGH_DATA = 1;
  OGRERR_NOT_ENOUGH_MEMORY = 2;
  OGRERR_UNSUPPORTED_GEOMETRY_TYPE = 3;
  OGRERR_UNSUPPORTED_OPERATION = 4;
  OGRERR_CORRUPT_DATA = 5;
  OGRERR_FAILURE = 6;
  OGRERR_UNSUPPORTED_SRS = 7;
  OGRERR_INVALID_HANDLE = 8;

type
  OGRBoolean = cint;
  OGRBooleanPtr = ^OGRBoolean;

const
  wkbUnknown = 0;
  wkbPoint = 1;
  wkbLineString = 2;
  wkbPolygon = 3;
  wkbMultiPoint = 4;
  wkbMultiLineString = 5;
  wkbMultiPolygon = 6;
  wkbGeometryCollection = 7;
  wkbNone = 100;
  wkbLinearRing = 101;
  wkbPoint25D = $80000001;
  wkbLineString25D = $80000002;
  wkbPolygon25D = $80000003;
  wkbMultiPoint25D = $80000004;
  wkbMultiLineString25D = $80000005;
  wkbMultiPolygon25D = $80000006;
  wkbGeometryCollection25D = $80000007;
type
  OGRwkbGeometryType = clong;
const
  wkbVariantOgc = 0;
  wkbVariantIso = 1;
type
  OGRwkbVariant = clong;

const
  wkb25DBit = $80000000;
  ogrZMarker = $21125711;
{$endif}

{$ifdef FUNCTIONS}
function OGRGeometryTypeToName(eType: OGRwkbGeometryType): charPtr; cdecl; external gdallib;
function OGRMergeGeometryTypes(eMain: OGRwkbGeometryType; eExtra: OGRwkbGeometryType): OGRwkbGeometryType; cdecl; external gdallib;
{$endif}

{$ifdef TYPES}
const
  wkbXDR = 0;
  wkbNDR = 1;
type
  OGRwkbByteOrder = clong;
{$endif}

{$ifdef TYPES}
const
  ALTER_NAME_FLAG = $1;
  ALTER_TYPE_FLAG = $2;
  ALTER_WIDTH_PRECISION_FLAG = $4;

const
  OFTInteger = 0;
  OFTIntegerList = 1;
  OFTReal = 2;
  OFTRealList = 3;
  OFTString = 4;
  OFTStringList = 5;
  OFTWideString = 6;
  OFTWideStringList = 7;
  OFTBinary = 8;
  OFTDate = 9;
  OFTTime = 10;
  OFTDateTime = 11;
  OFTMaxType = 11;
type
  OGRFieldType = clong;
const
  OJUndefined = 0;
  OJLeft = 1;
  OJRight = 2;
type
  OGRJustification = clong;

const
  OGRNullFID = -1;
  OGRUnsetMarker = -21121;

type
  OGRField = record
    case longint of
      0: (Integer: cint);
      1: (Real: double);
      2: (String_: charPtr);
      3: (
        IntegerList: record
          nCount: cint;
          paList: cintPtr;
        end;
      );
      4: (
        RealList: record
          nCount_: cint;
          paList_: doublePtr;
        end;
      );
      5: (
        StringList: record
          nCount_: cint;
          paList_: charPtrPtr;
        end;
      );
      6: (
        Binary: record
          nCount_: cint;
          paData: GBytePtr;
        end;
      );
      7: (
        Set_: record
          nMarker1: cint;
          nMarker2: cint;
        end;
      );
      8: (
        Date: record
          Year: GInt16;
          Month: GByte;
          Day: GByte;
          Hour: GByte;
          Minute: GByte;
          Second: GByte;
          TZFlag: GByte;
        end;
      );
  end;
type
  OGRFieldPtr = ^OGRField;
{$endif}

{$ifdef FUNCTIONS}
function OGRParseDate(pszInput: charPtr; psOutput: OGRFieldPtr; nOptions: cint): cint; cdecl; external gdallib;
{$endif}

{$ifdef TYPES}
const
  OLCRandomRead = 'RandomRead';
  OLCSequentialWrite = 'SequentialWrite';
  OLCRandomWrite = 'RandomWrite';
  OLCFastSpatialFilter = 'FastSpatialFilter';
  OLCFastFeatureCount = 'FastFeatureCount';
  OLCFastGetExtent = 'FastGetExtent';
  OLCCreateField = 'CreateField';
  OLCDeleteField = 'DeleteField';
  OLCReorderFields = 'ReorderFields';
  OLCAlterFieldDefn = 'AlterFieldDefn';
  OLCTransactions = 'Transactions';
  OLCDeleteFeature = 'DeleteFeature';
  OLCFastSetNextByIndex = 'FastSetNextByIndex';
  OLCStringsAsUTF8 = 'StringsAsUTF8';
  OLCIgnoreFields = 'IgnoreFields';
  OLCCreateGeomField = 'CreateGeomField';
  ODsCCreateLayer = 'CreateLayer';
  ODsCDeleteLayer = 'DeleteLayer';
  ODsCCreateGeomFieldAfterCreateLayer = 'CreateGeomFieldAfterCreateLayer';
  ODrCCreateDataSource = 'CreateDataSource';
  ODrCDeleteDataSource = 'DeleteDataSource';

const
  OGRSTCNone = 0;
  OGRSTCPen = 1;
  OGRSTCBrush = 2;
  OGRSTCSymbol = 3;
  OGRSTCLabel = 4;
  OGRSTCVector = 5;
type
  OGRSTClassId = clong;
const
  OGRSTUGround = 0;
  OGRSTUPixel = 1;
  OGRSTUPoints = 2;
  OGRSTUMM = 3;
  OGRSTUCM = 4;
  OGRSTUInches = 5;
type
  OGRSTUnitId = clong;
const
  OGRSTPenColor = 0;
  OGRSTPenWidth = 1;
  OGRSTPenPattern = 2;
  OGRSTPenId = 3;
  OGRSTPenPerOffset = 4;
  OGRSTPenCap = 5;
  OGRSTPenJoin = 6;
  OGRSTPenPriority = 7;
  OGRSTPenLast = 8;
type
  OGRSTPenParam = clong;
const
  OGRSTBrushFColor = 0;
  OGRSTBrushBColor = 1;
  OGRSTBrushId = 2;
  OGRSTBrushAngle = 3;
  OGRSTBrushSize = 4;
  OGRSTBrushDx = 5;
  OGRSTBrushDy = 6;
  OGRSTBrushPriority = 7;
  OGRSTBrushLast = 8;
type
  OGRSTBrushParam = clong;
const
  OGRSTSymbolId = 0;
  OGRSTSymbolAngle = 1;
  OGRSTSymbolColor = 2;
  OGRSTSymbolSize = 3;
  OGRSTSymbolDx = 4;
  OGRSTSymbolDy = 5;
  OGRSTSymbolStep = 6;
  OGRSTSymbolPerp = 7;
  OGRSTSymbolOffset = 8;
  OGRSTSymbolPriority = 9;
  OGRSTSymbolFontName = 10;
  OGRSTSymbolOColor = 11;
  OGRSTSymbolLast = 12;
type
  OGRSTSymbolParam = clong;
const
  OGRSTLabelFontName = 0;
  OGRSTLabelSize = 1;
  OGRSTLabelTextString = 2;
  OGRSTLabelAngle = 3;
  OGRSTLabelFColor = 4;
  OGRSTLabelBColor = 5;
  OGRSTLabelPlacement = 6;
  OGRSTLabelAnchor = 7;
  OGRSTLabelDx = 8;
  OGRSTLabelDy = 9;
  OGRSTLabelPerp = 10;
  OGRSTLabelBold = 11;
  OGRSTLabelItalic = 12;
  OGRSTLabelUnderline = 13;
  OGRSTLabelPriority = 14;
  OGRSTLabelStrikeout = 15;
  OGRSTLabelStretch = 16;
  OGRSTLabelAdjHor = 17;
  OGRSTLabelAdjVert = 18;
  OGRSTLabelHColor = 19;
  OGRSTLabelOColor = 20;
  OGRSTLabelLast = 21;
type
  OGRSTLabelParam = clong;
{$endif}

{$ifndef GDAL_VERSION_INFO_DEFINED}
{$ifdef FUNCTIONS}
function GDALVersionInfo_(param1: charPtr): charPtr; cdecl; external gdallib;
{$endif}

{$endif}

{$ifndef GDAL_CHECK_VERSION}
{$ifdef FUNCTIONS}
function GDALCheckVersion_(nVersionMajor: cint; nVersionMinor: cint; pszCallingComponentName: charPtr): cint; cdecl; external gdallib;
{$endif}

{$endif}
{$endif}
