{ Parsed from GDAL.framework ogr_srs_api.h }

{$ifndef _OGR_SRS_API_H_INCLUDED}

{$ifndef SWIG}
{$ifdef TYPES}
const
  OAO_Other = 0;
  OAO_North = 1;
  OAO_South = 2;
  OAO_East = 3;
  OAO_West = 4;
  OAO_Up = 5;
  OAO_Down = 6;
type
  OGRAxisOrientation = clong;
{$endif}

{$ifdef FUNCTIONS}
function OSRAxisEnumToName(eOrientation: OGRAxisOrientation): charPtr; cdecl; external gdallib;
{$endif}

{$ifdef TYPES}
const
  ODT_HD_Min = 1000;
  ODT_HD_Other = 1000;
  ODT_HD_Classic = 1001;
  ODT_HD_Geocentric = 1002;
  ODT_HD_Max = 1999;
  ODT_VD_Min = 2000;
  ODT_VD_Other = 2000;
  ODT_VD_Orthometric = 2001;
  ODT_VD_Ellipsoidal = 2002;
  ODT_VD_AltitudeBarometric = 2003;
  ODT_VD_Normal = 2004;
  ODT_VD_GeoidModelDerived = 2005;
  ODT_VD_Depth = 2006;
  ODT_VD_Max = 2999;
  ODT_LD_Min = 10000;
  ODT_LD_Max = 32767;
type
  OGRDatumType = clong;
{$endif}

{$endif}
{$ifdef TYPES}
const
  SRS_WKT_WGS84 = 'GEOGCS[''WGS 84'',DATUM[''WGS_1984'',SPHEROID[''WGS 84'',6378137,298.257223563,AUTHORITY[''EPSG'',''7030'']],TOWGS84[0,0,0,0,0,0,0],AUTHORITY[''EPSG'',''6326'']],PRIMEM[''Greenwich'',0,AUTHORITY[''EPSG'',''8901'']],' + 'UNIT[''degree'',0.0174532925199433,AUTHORITY[''EPSG'',''9108'']],AUTHORITY[''EPSG'',''4326'']]';
  SRS_PT_AZIMUTHAL_EQUIDISTANT = 'Azimuthal_Equidistant';
  SRS_PT_CASSINI_SOLDNER = 'Cassini_Soldner';
  SRS_PT_CYLINDRICAL_EQUAL_AREA = 'Cylindrical_Equal_Area';
  SRS_PT_BONNE = 'Bonne';
  SRS_PT_ECKERT_I = 'Eckert_I';
  SRS_PT_ECKERT_II = 'Eckert_II';
  SRS_PT_ECKERT_III = 'Eckert_III';
  SRS_PT_ECKERT_IV = 'Eckert_IV';
  SRS_PT_ECKERT_V = 'Eckert_V';
  SRS_PT_ECKERT_VI = 'Eckert_VI';
  SRS_PT_EQUIRECTANGULAR = 'Equirectangular';
  SRS_PT_GOODE_HOMOLOSINE = 'Goode_Homolosine';
  SRS_PT_IGH = 'Interrupted_Goode_Homolosine';
  SRS_PT_GNOMONIC = 'Gnomonic';
  SRS_PT_MERCATOR_1SP = 'Mercator_1SP';
  SRS_PT_MERCATOR_2SP = 'Mercator_2SP';
  SRS_PT_MILLER_CYLINDRICAL = 'Miller_Cylindrical';
  SRS_PT_MOLLWEIDE = 'Mollweide';
  SRS_PT_ORTHOGRAPHIC = 'Orthographic';
  SRS_PT_POLYCONIC = 'Polyconic';
  SRS_PT_ROBINSON = 'Robinson';
  SRS_PT_SINUSOIDAL = 'Sinusoidal';
  SRS_PT_STEREOGRAPHIC = 'Stereographic';
  SRS_PT_VANDERGRINTEN = 'VanDerGrinten';
  SRS_PT_KROVAK = 'Krovak';
  SRS_PT_IMW_POLYCONIC = 'International_Map_of_the_World_Polyconic';
  SRS_PT_WAGNER_I = 'Wagner_I';
  SRS_PT_WAGNER_II = 'Wagner_II';
  SRS_PT_WAGNER_III = 'Wagner_III';
  SRS_PT_WAGNER_IV = 'Wagner_IV';
  SRS_PT_WAGNER_V = 'Wagner_V';
  SRS_PT_WAGNER_VI = 'Wagner_VI';
  SRS_PT_WAGNER_VII = 'Wagner_VII';
  SRS_PP_CENTRAL_MERIDIAN = 'central_meridian';
  SRS_PP_SCALE_FACTOR = 'scale_factor';
  SRS_PP_STANDARD_PARALLEL_1 = 'standard_parallel_1';
  SRS_PP_STANDARD_PARALLEL_2 = 'standard_parallel_2';
  SRS_PP_PSEUDO_STD_PARALLEL_1 = 'pseudo_standard_parallel_1';
  SRS_PP_LONGITUDE_OF_CENTER = 'longitude_of_center';
  SRS_PP_LATITUDE_OF_CENTER = 'latitude_of_center';
  SRS_PP_LONGITUDE_OF_ORIGIN = 'longitude_of_origin';
  SRS_PP_LATITUDE_OF_ORIGIN = 'latitude_of_origin';
  SRS_PP_FALSE_EASTING = 'false_easting';
  SRS_PP_FALSE_NORTHING = 'false_northing';
  SRS_PP_AZIMUTH = 'azimuth';
  SRS_PP_LONGITUDE_OF_POINT_1 = 'longitude_of_point_1';
  SRS_PP_LATITUDE_OF_POINT_1 = 'latitude_of_point_1';
  SRS_PP_LONGITUDE_OF_POINT_2 = 'longitude_of_point_2';
  SRS_PP_LATITUDE_OF_POINT_2 = 'latitude_of_point_2';
  SRS_PP_LONGITUDE_OF_POINT_3 = 'longitude_of_point_3';
  SRS_PP_LATITUDE_OF_POINT_3 = 'latitude_of_point_3';
  SRS_PP_RECTIFIED_GRID_ANGLE = 'rectified_grid_angle';
  SRS_PP_LANDSAT_NUMBER = 'landsat_number';
  SRS_PP_PATH_NUMBER = 'path_number';
  SRS_PP_PERSPECTIVE_POINT_HEIGHT = 'perspective_point_height';
  SRS_PP_SATELLITE_HEIGHT = 'satellite_height';
  SRS_PP_FIPSZONE = 'fipszone';
  SRS_PP_ZONE = 'zone';
  SRS_PP_LATITUDE_OF_1ST_POINT = 'Latitude_Of_1st_Point';
  SRS_PP_LONGITUDE_OF_1ST_POINT = 'Longitude_Of_1st_Point';
  SRS_PP_LATITUDE_OF_2ND_POINT = 'Latitude_Of_2nd_Point';
  SRS_PP_LONGITUDE_OF_2ND_POINT = 'Longitude_Of_2nd_Point';
  SRS_UL_METER = 'Meter';
  SRS_UL_FOOT_CONV = '0.3048';
  SRS_UL_US_FOOT = 'Foot_US';
  SRS_UL_US_FOOT_CONV = '0.3048006096012192';
  SRS_UL_NAUTICAL_MILE = 'Nautical Mile';
  SRS_UL_NAUTICAL_MILE_CONV = '1852.0';
  SRS_UL_LINK = 'Link';
  SRS_UL_LINK_CONV = '0.20116684023368047';
  SRS_UL_CHAIN = 'Chain';
  SRS_UL_CHAIN_CONV = '20.116684023368047';
  SRS_UL_ROD = 'Rod';
  SRS_UL_ROD_CONV = '5.02921005842012';
  SRS_UL_LINK_Clarke = 'Link_Clarke';
  SRS_UL_LINK_Clarke_CONV = '0.2011661949';
  SRS_UL_KILOMETER = 'Kilometer';
  SRS_UL_KILOMETER_CONV = '1000.';
  SRS_UL_DECIMETER = 'Decimeter';
  SRS_UL_DECIMETER_CONV = '0.1';
  SRS_UL_CENTIMETER = 'Centimeter';
  SRS_UL_CENTIMETER_CONV = '0.01';
  SRS_UL_MILLIMETER = 'Millimeter';
  SRS_UL_MILLIMETER_CONV = '0.001';
  SRS_UL_INTL_NAUT_MILE = 'Nautical_Mile_International';
  SRS_UL_INTL_NAUT_MILE_CONV = '1852.0';
  SRS_UL_INTL_INCH = 'Inch_International';
  SRS_UL_INTL_INCH_CONV = '0.0254';
  SRS_UL_INTL_FOOT = 'Foot_International';
  SRS_UL_INTL_FOOT_CONV = '0.3048';
  SRS_UL_INTL_YARD = 'Yard_International';
  SRS_UL_INTL_YARD_CONV = '0.9144';
  SRS_UL_INTL_STAT_MILE = 'Statute_Mile_International';
  SRS_UL_INTL_STAT_MILE_CONV = '1609.344';
  SRS_UL_INTL_FATHOM = 'Fathom_International';
  SRS_UL_INTL_FATHOM_CONV = '1.8288';
  SRS_UL_INTL_CHAIN = 'Chain_International';
  SRS_UL_INTL_CHAIN_CONV = '20.1168';
  SRS_UL_INTL_LINK = 'Link_International';
  SRS_UL_INTL_LINK_CONV = '0.201168';
  SRS_UL_US_INCH = 'Inch_US_Surveyor';
  SRS_UL_US_INCH_CONV = '0.025400050800101603';
  SRS_UL_US_YARD = 'Yard_US_Surveyor';
  SRS_UL_US_YARD_CONV = '0.914401828803658';
  SRS_UL_US_CHAIN = 'Chain_US_Surveyor';
  SRS_UL_US_CHAIN_CONV = '20.11684023368047';
  SRS_UL_US_STAT_MILE = 'Statute_Mile_US_Surveyor';
  SRS_UL_US_STAT_MILE_CONV = '1609.347218694437';
  SRS_UL_INDIAN_YARD = 'Yard_Indian';
  SRS_UL_INDIAN_YARD_CONV = '0.91439523';
  SRS_UL_INDIAN_FOOT = 'Foot_Indian';
  SRS_UL_INDIAN_FOOT_CONV = '0.30479841';
  SRS_UL_INDIAN_CHAIN = 'Chain_Indian';
  SRS_UL_INDIAN_CHAIN_CONV = '20.11669506';
  SRS_UA_DEGREE = 'degree';
  SRS_UA_DEGREE_CONV = '0.0174532925199433';
  SRS_UA_RADIAN = 'radian';
  SRS_PM_GREENWICH = 'Greenwich';
  SRS_DN_NAD27 = 'North_American_Datum_1927';
  SRS_DN_NAD83 = 'North_American_Datum_1983';
  SRS_DN_WGS72 = 'WGS_1972';
  SRS_DN_WGS84 = 'WGS_1984';
  SRS_WGS84_SEMIMAJOR = 6378137.0;
  SRS_WGS84_INVFLATTENING = 298.257223563;
{$endif}

{$ifndef SWIG}

{$ifndef _DEFINED_OGRSpatialReferenceH}
{$define _DEFINED_OGRSpatialReferenceH}

{$ifdef DEBUG}
{$ifdef TYPES}
type
  OGRSpatialReferenceH = OpaqueType;
  OGRCoordinateTransformationH = OpaqueType;
{$endif}

{$else}
{$ifdef TYPES}
type
  OGRSpatialReferenceH = ^pointer;
  OGRCoordinateTransformationH = ^pointer;
{$endif}

{$endif}
{$endif}
{$ifdef FUNCTIONS}
function OSRNewSpatialReference(param1: charPtr): OGRSpatialReferenceH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRNewSpatialReference@4'{$ENDIF};
function OSRCloneGeogCS(param1: OGRSpatialReferenceH): OGRSpatialReferenceH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRCloneGeogCS@4'{$ENDIF};
function OSRClone(param1: OGRSpatialReferenceH): OGRSpatialReferenceH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRClone@4'{$ENDIF};
procedure OSRDestroySpatialReference(param1: OGRSpatialReferenceH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRDestroySpatialReference@4'{$ENDIF};
function OSRReference(param1: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRDereference(param1: OGRSpatialReferenceH): cint; cdecl; external gdallib;
procedure OSRRelease(param1: OGRSpatialReferenceH); cdecl; external gdallib;
function OSRValidate(param1: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSRFixupOrdering(param1: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSRFixup(param1: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSRStripCTParms(param1: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSRImportFromEPSG(param1: OGRSpatialReferenceH; param2: cint): OGRErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRImportFromEPSG@8'{$ENDIF};
function OSRImportFromEPSGA(param1: OGRSpatialReferenceH; param2: cint): OGRErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRImportFromEPSGA@8'{$ENDIF};
function OSRImportFromWkt(param1: OGRSpatialReferenceH; param2: charPtrPtr): OGRErr; cdecl; external gdallib;
function OSRImportFromProj4(param1: OGRSpatialReferenceH; param2: charPtr): OGRErr; cdecl; external gdallib;
function OSRImportFromESRI(param1: OGRSpatialReferenceH; param2: charPtrPtr): OGRErr; cdecl; external gdallib;
function OSRImportFromPCI(hSRS: OGRSpatialReferenceH; param2: charPtr; param3: charPtr; param4: doublePtr): OGRErr; cdecl; external gdallib;
function OSRImportFromUSGS(param1: OGRSpatialReferenceH; param2: clong; param3: clong; param4: doublePtr; param5: clong): OGRErr; cdecl; external gdallib;
function OSRImportFromXML(param1: OGRSpatialReferenceH; param2: charPtr): OGRErr; cdecl; external gdallib;
function OSRImportFromDict(param1: OGRSpatialReferenceH; param2: charPtr; param3: charPtr): OGRErr; cdecl; external gdallib;
function OSRImportFromPanorama(param1: OGRSpatialReferenceH; param2: clong; param3: clong; param4: clong; param5: doublePtr): OGRErr; cdecl; external gdallib;
function OSRImportFromOzi(param1: OGRSpatialReferenceH; param2: charPtr; param3: charPtr; param4: charPtr): OGRErr; cdecl; external gdallib;
function OSRImportFromMICoordSys(param1: OGRSpatialReferenceH; param2: charPtr): OGRErr; cdecl; external gdallib;
function OSRImportFromERM(param1: OGRSpatialReferenceH; param2: charPtr; param3: charPtr; param4: charPtr): OGRErr; cdecl; external gdallib;
function OSRImportFromUrl(param1: OGRSpatialReferenceH; param2: charPtr): OGRErr; cdecl; external gdallib;
function OSRExportToWkt(param1: OGRSpatialReferenceH; param2: charPtrPtr): OGRErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRExportToWkt@8'{$ENDIF};
function OSRExportToPrettyWkt(param1: OGRSpatialReferenceH; param2: charPtrPtr; param3: cint): OGRErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRExportToPrettyWkt@12'{$ENDIF};
function OSRExportToProj4(param1: OGRSpatialReferenceH; param2: charPtrPtr): OGRErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRExportToProj4@8'{$ENDIF};
function OSRExportToPCI(param1: OGRSpatialReferenceH; param2: charPtrPtr; param3: charPtrPtr; param4: doublePtrPtr): OGRErr; cdecl; external gdallib;
function OSRExportToUSGS(param1: OGRSpatialReferenceH; param2: clongPtr; param3: clongPtr; param4: doublePtrPtr; param5: clongPtr): OGRErr; cdecl; external gdallib;
function OSRExportToXML(param1: OGRSpatialReferenceH; param2: charPtrPtr; param3: charPtr): OGRErr; cdecl; external gdallib;
function OSRExportToPanorama(param1: OGRSpatialReferenceH; param2: clongPtr; param3: clongPtr; param4: clongPtr; param5: clongPtr; param6: doublePtr): OGRErr; cdecl; external gdallib;
function OSRExportToMICoordSys(param1: OGRSpatialReferenceH; param2: charPtrPtr): OGRErr; cdecl; external gdallib;
function OSRExportToERM(param1: OGRSpatialReferenceH; param2: charPtr; param3: charPtr; param4: charPtr): OGRErr; cdecl; external gdallib;
function OSRMorphToESRI(param1: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSRMorphFromESRI(param1: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSRSetAttrValue(hSRS: OGRSpatialReferenceH; pszNodePath: charPtr; pszNewNodeValue: charPtr): OGRErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRSetAttrValue@12'{$ENDIF};
function OSRGetAttrValue(hSRS: OGRSpatialReferenceH; pszName: charPtr; iChild: cint): charPtr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRGetAttrValue@12'{$ENDIF};
function OSRSetAngularUnits(param1: OGRSpatialReferenceH; param2: charPtr; param3: double): OGRErr; cdecl; external gdallib;
function OSRGetAngularUnits(param1: OGRSpatialReferenceH; param2: charPtrPtr): double; cdecl; external gdallib;
function OSRSetLinearUnits(param1: OGRSpatialReferenceH; param2: charPtr; param3: double): OGRErr; cdecl; external gdallib;
function OSRSetTargetLinearUnits(param1: OGRSpatialReferenceH; param2: charPtr; param3: charPtr; param4: double): OGRErr; cdecl; external gdallib;
function OSRSetLinearUnitsAndUpdateParameters(param1: OGRSpatialReferenceH; param2: charPtr; param3: double): OGRErr; cdecl; external gdallib;
function OSRGetLinearUnits(param1: OGRSpatialReferenceH; param2: charPtrPtr): double; cdecl; external gdallib;
function OSRGetTargetLinearUnits(param1: OGRSpatialReferenceH; param2: charPtr; param3: charPtrPtr): double; cdecl; external gdallib;
function OSRGetPrimeMeridian(param1: OGRSpatialReferenceH; param2: charPtrPtr): double; cdecl; external gdallib;
function OSRIsGeographic(param1: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRIsLocal(param1: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRIsProjected(param1: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRIsCompound(param1: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRIsGeocentric(param1: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRIsVertical(param1: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRIsSameGeogCS(param1: OGRSpatialReferenceH; param2: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRIsSameVertCS(param1: OGRSpatialReferenceH; param2: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRIsSame(param1: OGRSpatialReferenceH; param2: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRSetLocalCS(hSRS: OGRSpatialReferenceH; pszName: charPtr): OGRErr; cdecl; external gdallib;
function OSRSetProjCS(hSRS: OGRSpatialReferenceH; pszName: charPtr): OGRErr; cdecl; external gdallib;
function OSRSetGeocCS(hSRS: OGRSpatialReferenceH; pszName: charPtr): OGRErr; cdecl; external gdallib;
function OSRSetWellKnownGeogCS(hSRS: OGRSpatialReferenceH; pszName: charPtr): OGRErr; cdecl; external gdallib;
function OSRSetFromUserInput(hSRS: OGRSpatialReferenceH; param2: charPtr): OGRErr; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OSRSetFromUserInput@8'{$ENDIF};
function OSRCopyGeogCSFrom(hSRS: OGRSpatialReferenceH; hSrcSRS: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSRSetTOWGS84(hSRS: OGRSpatialReferenceH; param2: double; param3: double; param4: double; param5: double; param6: double; param7: double; param8: double): OGRErr; cdecl; external gdallib;
function OSRGetTOWGS84(hSRS: OGRSpatialReferenceH; param2: doublePtr; param3: cint): OGRErr; cdecl; external gdallib;
function OSRSetCompoundCS(hSRS: OGRSpatialReferenceH; pszName: charPtr; hHorizSRS: OGRSpatialReferenceH; hVertSRS: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSRSetGeogCS(hSRS: OGRSpatialReferenceH; pszGeogName: charPtr; pszDatumName: charPtr; pszEllipsoidName: charPtr; dfSemiMajor: double; dfInvFlattening: double; pszPMName: charPtr; dfPMOffset: double; pszUnits: charPtr; dfConvertToRadians: double): OGRErr; cdecl; external gdallib;
function OSRSetVertCS(hSRS: OGRSpatialReferenceH; pszVertCSName: charPtr; pszVertDatumName: charPtr; nVertDatumType: cint): OGRErr; cdecl; external gdallib;
function OSRGetSemiMajor(param1: OGRSpatialReferenceH; param2: OGRErrPtr): double; cdecl; external gdallib;
function OSRGetSemiMinor(param1: OGRSpatialReferenceH; param2: OGRErrPtr): double; cdecl; external gdallib;
function OSRGetInvFlattening(param1: OGRSpatialReferenceH; param2: OGRErrPtr): double; cdecl; external gdallib;
function OSRSetAuthority(hSRS: OGRSpatialReferenceH; pszTargetKey: charPtr; pszAuthority: charPtr; nCode: cint): OGRErr; cdecl; external gdallib;
function OSRGetAuthorityCode(hSRS: OGRSpatialReferenceH; pszTargetKey: charPtr): charPtr; cdecl; external gdallib;
function OSRGetAuthorityName(hSRS: OGRSpatialReferenceH; pszTargetKey: charPtr): charPtr; cdecl; external gdallib;
function OSRSetProjection(param1: OGRSpatialReferenceH; param2: charPtr): OGRErr; cdecl; external gdallib;
function OSRSetProjParm(param1: OGRSpatialReferenceH; param2: charPtr; param3: double): OGRErr; cdecl; external gdallib;
function OSRGetProjParm(hSRS: OGRSpatialReferenceH; pszParmName: charPtr; dfDefault: double; param4: OGRErrPtr): double; cdecl; external gdallib;
function OSRSetNormProjParm(param1: OGRSpatialReferenceH; param2: charPtr; param3: double): OGRErr; cdecl; external gdallib;
function OSRGetNormProjParm(hSRS: OGRSpatialReferenceH; pszParmName: charPtr; dfDefault: double; param4: OGRErrPtr): double; cdecl; external gdallib;
function OSRSetUTM(hSRS: OGRSpatialReferenceH; nZone: cint; bNorth: cint): OGRErr; cdecl; external gdallib;
function OSRGetUTMZone(hSRS: OGRSpatialReferenceH; pbNorth: cintPtr): cint; cdecl; external gdallib;
function OSRSetStatePlane(hSRS: OGRSpatialReferenceH; nZone: cint; bNAD83: cint): OGRErr; cdecl; external gdallib;
function OSRSetStatePlaneWithUnits(hSRS: OGRSpatialReferenceH; nZone: cint; bNAD83: cint; pszOverrideUnitName: charPtr; dfOverrideUnit: double): OGRErr; cdecl; external gdallib;
function OSRAutoIdentifyEPSG(hSRS: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSREPSGTreatsAsLatLong(hSRS: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSREPSGTreatsAsNorthingEasting(hSRS: OGRSpatialReferenceH): cint; cdecl; external gdallib;
function OSRGetAxis(hSRS: OGRSpatialReferenceH; pszTargetKey: charPtr; iAxis: cint; peOrientation: OGRAxisOrientationPtr): charPtr; cdecl; external gdallib;
function OSRSetAxes(pszTargetKey: charPtr; pszXAxisName: charPtr; eXAxisOrientation: OGRAxisOrientation; pszYAxisName: charPtr; eYAxisOrientation: OGRAxisOrientation): OGRErr; cdecl; external gdallib;
function OSRSetACEA(hSRS: OGRSpatialReferenceH; dfStdP1: double; dfStdP2: double; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetAE(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetBonne(hSRS: OGRSpatialReferenceH; dfStandardParallel: double; dfCentralMeridian: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetCEA(hSRS: OGRSpatialReferenceH; dfStdP1: double; dfCentralMeridian: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetCS(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetEC(hSRS: OGRSpatialReferenceH; dfStdP1: double; dfStdP2: double; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetEckert(hSRS: OGRSpatialReferenceH; nVariation: cint; dfCentralMeridian: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetEckertIV(hSRS: OGRSpatialReferenceH; dfCentralMeridian: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetEckertVI(hSRS: OGRSpatialReferenceH; dfCentralMeridian: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetEquirectangular(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetEquirectangular2(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfPseudoStdParallel1: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetGS(hSRS: OGRSpatialReferenceH; dfCentralMeridian: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetGH(hSRS: OGRSpatialReferenceH; dfCentralMeridian: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetIGH(hSRS: OGRSpatialReferenceH): OGRErr; cdecl; external gdallib;
function OSRSetGEOS(hSRS: OGRSpatialReferenceH; dfCentralMeridian: double; dfSatelliteHeight: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetGaussSchreiberTMercator(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetGnomonic(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetOM(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfAzimuth: double; dfRectToSkew: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetHOM(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfAzimuth: double; dfRectToSkew: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetHOM2PNO(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfLat1: double; dfLong1: double; dfLat2: double; dfLong2: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetIWMPolyconic(hSRS: OGRSpatialReferenceH; dfLat1: double; dfLat2: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetKrovak(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfAzimuth: double; dfPseudoStdParallelLat: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetLAEA(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetLCC(hSRS: OGRSpatialReferenceH; dfStdP1: double; dfStdP2: double; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetLCC1SP(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetLCCB(hSRS: OGRSpatialReferenceH; dfStdP1: double; dfStdP2: double; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetMC(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetMercator(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetMollweide(hSRS: OGRSpatialReferenceH; dfCentralMeridian: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetNZMG(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetOS(hSRS: OGRSpatialReferenceH; dfOriginLat: double; dfCMeridian: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetOrthographic(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetPolyconic(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetPS(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetRobinson(hSRS: OGRSpatialReferenceH; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetSinusoidal(hSRS: OGRSpatialReferenceH; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetStereographic(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetSOC(hSRS: OGRSpatialReferenceH; dfLatitudeOfOrigin: double; dfCentralMeridian: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetTM(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetTMVariant(hSRS: OGRSpatialReferenceH; pszVariantName: charPtr; dfCenterLat: double; dfCenterLong: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetTMG(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetTMSO(hSRS: OGRSpatialReferenceH; dfCenterLat: double; dfCenterLong: double; dfScale: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetVDG(hSRS: OGRSpatialReferenceH; dfCenterLong: double; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
function OSRSetWagner(hSRS: OGRSpatialReferenceH; nVariation: cint; dfFalseEasting: double; dfFalseNorthing: double): OGRErr; cdecl; external gdallib;
procedure OSRCleanup; cdecl; external gdallib;
function OCTNewCoordinateTransformation(hSourceSRS: OGRSpatialReferenceH; hTargetSRS: OGRSpatialReferenceH): OGRCoordinateTransformationH; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OCTNewCoordinateTransformation@8'{$ENDIF};
procedure OCTDestroyCoordinateTransformation(param1: OGRCoordinateTransformationH); {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OCTDestroyCoordinateTransformation@4'{$ENDIF};
function OCTTransform(hCT: OGRCoordinateTransformationH; nCount: cint; x: doublePtr; y: doublePtr; z: doublePtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OCTTransform@20'{$ENDIF};
function OCTTransformEx(hCT: OGRCoordinateTransformationH; nCount: cint; x: doublePtr; y: doublePtr; z: doublePtr; pabSuccess: cintPtr): cint; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF}; external gdallib {$IFDEF WIN32}name '_OCTTransformEx@24'{$ENDIF};
function OCTProj4Normalize(pszProj4Src: charPtr): charPtr; cdecl; external gdallib;
procedure OCTCleanupProjMutex; cdecl; external gdallib;
function OPTGetProjectionMethods: charPtrPtr; cdecl; external gdallib;
function OPTGetParameterList(pszProjectionMethod: charPtr; ppszUserName: charPtrPtr): charPtrPtr; cdecl; external gdallib;
function OPTGetParameterInfo(pszProjectionMethod: charPtr; pszParameterName: charPtr; ppszUserName: charPtrPtr; ppszType: charPtrPtr; pdfDefaultValue: doublePtr): cint; cdecl; external gdallib;
{$endif}

{$endif}
{$endif}
