{
This unit has been produced by ws_helper.
  Input unit name : "ndfdXML".
  This unit name  : "ndfdXML_proxy".
  Date            : "21-2-17 17:46:04".
}

Unit ndfdXML_proxy;
{$IFDEF FPC} {$mode objfpc}{$H+} {$ENDIF}
Interface

Uses SysUtils, Classes, TypInfo, base_service_intf, service_intf, ndfdXML;

Type


  TndfdXMLPortType_Proxy=class(TBaseProxy,ndfdXML.ndfdXMLPortType)
  Protected
    class function GetServiceType() : PTypeInfo;override;
    function NDFDgen(
      const  latitude : Currency; 
      const  longitude : Currency; 
      const  product : string; 
      const  startTime : TDateTimeRemotable; 
      const  endTime : TDateTimeRemotable; 
      const  _Unit : string; 
      const  weatherParameters : weatherParametersType
    ):string;
    function NDFDgenLatLonList(
      const  listLatLon : string; 
      const  product : string; 
      const  startTime : TDateTimeRemotable; 
      const  endTime : TDateTimeRemotable; 
      const  _Unit : string; 
      const  weatherParameters : weatherParametersType
    ):string;
    function LatLonListSubgrid(
      const  lowerLeftLatitude : Currency; 
      const  lowerLeftLongitude : Currency; 
      const  upperRightLatitude : Currency; 
      const  upperRightLongitude : Currency; 
      const  resolution : Currency
    ):string;
    function LatLonListLine(
      const  endPoint1Lat : Currency; 
      const  endPoint1Lon : Currency; 
      const  endPoint2Lat : Currency; 
      const  endPoint2Lon : Currency
    ):string;
    function LatLonListZipCode(
      const  zipCodeList : string
    ):string;
    function LatLonListCityNames(
      const  displayLevel : integer
    ):string;
    function LatLonListSquare(
      const  centerPointLat : Currency; 
      const  centerPointLon : Currency; 
      const  distanceLat : Currency; 
      const  distanceLon : Currency; 
      const  resolution : Currency
    ):string;
    function CornerPoints(
      const  sector : string
    ):string;
    function GmlLatLonList(
      const  listLatLon : string; 
      const  requestedTime : TDateTimeRemotable; 
      const  featureType : string; 
      const  weatherParameters : weatherParametersType
    ):string;
    function GmlTimeSeries(
      const  listLatLon : string; 
      const  startTime : TDateTimeRemotable; 
      const  endTime : TDateTimeRemotable; 
      const  compType : string; 
      const  featureType : string; 
      const  propertyName : string
    ):string;
    function NDFDgenByDay(
      const  latitude : Currency; 
      const  longitude : Currency; 
      const  startDate : TDateRemotable; 
      const  numDays : integer; 
      const  _Unit : string; 
      const  format : string
    ):string;
    function NDFDgenByDayLatLonList(
      const  listLatLon : string; 
      const  startDate : TDateRemotable; 
      const  numDays : integer; 
      const  _Unit : string; 
      const  format : string
    ):string;
  End;

  Function wst_CreateInstance_ndfdXMLPortType(const AFormat : string = 'SOAP:'; const ATransport : string = 'HTTP:'; const AAddress : string = ''):ndfdXMLPortType;

Implementation
uses wst_resources_imp, metadata_repository;


Function wst_CreateInstance_ndfdXMLPortType(const AFormat : string; const ATransport : string; const AAddress : string):ndfdXMLPortType;
Var
  locAdr : string;
Begin
  locAdr := AAddress;
  if ( locAdr = '' ) then
    locAdr := GetServiceDefaultAddress(TypeInfo(ndfdXMLPortType));
  Result := TndfdXMLPortType_Proxy.Create('ndfdXMLPortType',AFormat+GetServiceDefaultFormatProperties(TypeInfo(ndfdXMLPortType)),ATransport + 'address=' + locAdr);
End;

{ TndfdXMLPortType_Proxy implementation }

class function TndfdXMLPortType_Proxy.GetServiceType() : PTypeInfo;
begin
  result := TypeInfo(ndfdXML.ndfdXMLPortType);
end;

function TndfdXMLPortType_Proxy.NDFDgen(
  const  latitude : Currency; 
  const  longitude : Currency; 
  const  product : string; 
  const  startTime : TDateTimeRemotable; 
  const  endTime : TDateTimeRemotable; 
  const  _Unit : string; 
  const  weatherParameters : weatherParametersType
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('NDFDgen', GetTarget(),locCallContext);
      locSerializer.Put('latitude', TypeInfo(Currency), latitude);
      locSerializer.Put('longitude', TypeInfo(Currency), longitude);
      locSerializer.Put('product', TypeInfo(string), product);
      locSerializer.Put('startTime', TypeInfo(TDateTimeRemotable), startTime);
      locSerializer.Put('endTime', TypeInfo(TDateTimeRemotable), endTime);
      locSerializer.Put('Unit', TypeInfo(string), _Unit);
      locSerializer.Put('weatherParameters', TypeInfo(weatherParametersType), weatherParameters);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'dwmlOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.NDFDgenLatLonList(
  const  listLatLon : string; 
  const  product : string; 
  const  startTime : TDateTimeRemotable; 
  const  endTime : TDateTimeRemotable; 
  const  _Unit : string; 
  const  weatherParameters : weatherParametersType
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('NDFDgenLatLonList', GetTarget(),locCallContext);
      locSerializer.Put('listLatLon', TypeInfo(string), listLatLon);
      locSerializer.Put('product', TypeInfo(string), product);
      locSerializer.Put('startTime', TypeInfo(TDateTimeRemotable), startTime);
      locSerializer.Put('endTime', TypeInfo(TDateTimeRemotable), endTime);
      locSerializer.Put('Unit', TypeInfo(string), _Unit);
      locSerializer.Put('weatherParameters', TypeInfo(weatherParametersType), weatherParameters);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'dwmlOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.LatLonListSubgrid(
  const  lowerLeftLatitude : Currency; 
  const  lowerLeftLongitude : Currency; 
  const  upperRightLatitude : Currency; 
  const  upperRightLongitude : Currency; 
  const  resolution : Currency
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('LatLonListSubgrid', GetTarget(),locCallContext);
      locSerializer.Put('lowerLeftLatitude', TypeInfo(Currency), lowerLeftLatitude);
      locSerializer.Put('lowerLeftLongitude', TypeInfo(Currency), lowerLeftLongitude);
      locSerializer.Put('upperRightLatitude', TypeInfo(Currency), upperRightLatitude);
      locSerializer.Put('upperRightLongitude', TypeInfo(Currency), upperRightLongitude);
      locSerializer.Put('resolution', TypeInfo(Currency), resolution);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'listLatLonOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.LatLonListLine(
  const  endPoint1Lat : Currency; 
  const  endPoint1Lon : Currency; 
  const  endPoint2Lat : Currency; 
  const  endPoint2Lon : Currency
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('LatLonListLine', GetTarget(),locCallContext);
      locSerializer.Put('endPoint1Lat', TypeInfo(Currency), endPoint1Lat);
      locSerializer.Put('endPoint1Lon', TypeInfo(Currency), endPoint1Lon);
      locSerializer.Put('endPoint2Lat', TypeInfo(Currency), endPoint2Lat);
      locSerializer.Put('endPoint2Lon', TypeInfo(Currency), endPoint2Lon);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'listLatLonOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.LatLonListZipCode(
  const  zipCodeList : string
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('LatLonListZipCode', GetTarget(),locCallContext);
      locSerializer.Put('zipCodeList', TypeInfo(string), zipCodeList);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'listLatLonOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.LatLonListCityNames(
  const  displayLevel : integer
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('LatLonListCityNames', GetTarget(),locCallContext);
      locSerializer.Put('displayLevel', TypeInfo(integer), displayLevel);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'listLatLonOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.LatLonListSquare(
  const  centerPointLat : Currency; 
  const  centerPointLon : Currency; 
  const  distanceLat : Currency; 
  const  distanceLon : Currency; 
  const  resolution : Currency
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('LatLonListSquare', GetTarget(),locCallContext);
      locSerializer.Put('centerPointLat', TypeInfo(Currency), centerPointLat);
      locSerializer.Put('centerPointLon', TypeInfo(Currency), centerPointLon);
      locSerializer.Put('distanceLat', TypeInfo(Currency), distanceLat);
      locSerializer.Put('distanceLon', TypeInfo(Currency), distanceLon);
      locSerializer.Put('resolution', TypeInfo(Currency), resolution);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'listLatLonOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.CornerPoints(
  const  sector : string
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('CornerPoints', GetTarget(),locCallContext);
      locSerializer.Put('sector', TypeInfo(string), sector);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'listLatLonOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.GmlLatLonList(
  const  listLatLon : string; 
  const  requestedTime : TDateTimeRemotable; 
  const  featureType : string; 
  const  weatherParameters : weatherParametersType
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('GmlLatLonList', GetTarget(),locCallContext);
      locSerializer.Put('listLatLon', TypeInfo(string), listLatLon);
      locSerializer.Put('requestedTime', TypeInfo(TDateTimeRemotable), requestedTime);
      locSerializer.Put('featureType', TypeInfo(string), featureType);
      locSerializer.Put('weatherParameters', TypeInfo(weatherParametersType), weatherParameters);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'dwGmlOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.GmlTimeSeries(
  const  listLatLon : string; 
  const  startTime : TDateTimeRemotable; 
  const  endTime : TDateTimeRemotable; 
  const  compType : string; 
  const  featureType : string; 
  const  propertyName : string
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('GmlTimeSeries', GetTarget(),locCallContext);
      locSerializer.Put('listLatLon', TypeInfo(string), listLatLon);
      locSerializer.Put('startTime', TypeInfo(TDateTimeRemotable), startTime);
      locSerializer.Put('endTime', TypeInfo(TDateTimeRemotable), endTime);
      locSerializer.Put('compType', TypeInfo(string), compType);
      locSerializer.Put('featureType', TypeInfo(string), featureType);
      locSerializer.Put('propertyName', TypeInfo(string), propertyName);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'dwGmlOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.NDFDgenByDay(
  const  latitude : Currency; 
  const  longitude : Currency; 
  const  startDate : TDateRemotable; 
  const  numDays : integer; 
  const  _Unit : string; 
  const  format : string
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('NDFDgenByDay', GetTarget(),locCallContext);
      locSerializer.Put('latitude', TypeInfo(Currency), latitude);
      locSerializer.Put('longitude', TypeInfo(Currency), longitude);
      locSerializer.Put('startDate', TypeInfo(TDateRemotable), startDate);
      locSerializer.Put('numDays', TypeInfo(integer), numDays);
      locSerializer.Put('Unit', TypeInfo(string), _Unit);
      locSerializer.Put('format', TypeInfo(string), format);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'dwmlByDayOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;

function TndfdXMLPortType_Proxy.NDFDgenByDayLatLonList(
  const  listLatLon : string; 
  const  startDate : TDateRemotable; 
  const  numDays : integer; 
  const  _Unit : string; 
  const  format : string
):string;
Var
  locSerializer : IFormatterClient;
  locCallContext : ICallContext;
  locStrPrmName : string;
Begin
  locCallContext := Self as ICallContext;
  locSerializer := GetSerializer();
  Try
    locSerializer.BeginCall('NDFDgenByDayLatLonList', GetTarget(),locCallContext);
      locSerializer.Put('listLatLon', TypeInfo(string), listLatLon);
      locSerializer.Put('startDate', TypeInfo(TDateRemotable), startDate);
      locSerializer.Put('numDays', TypeInfo(integer), numDays);
      locSerializer.Put('Unit', TypeInfo(string), _Unit);
      locSerializer.Put('format', TypeInfo(string), format);
    locSerializer.EndCall();

    MakeCall();

    locSerializer.BeginCallRead(locCallContext);
      locStrPrmName := 'dwmlByDayOut';
      locSerializer.Get(TypeInfo(string), locStrPrmName, Result);

  Finally
    locSerializer.Clear();
  End;
End;


initialization
  {$i ndfdXML.wst}

  {$IF DECLARED(Register_ndfdXML_ServiceMetadata)}
  Register_ndfdXML_ServiceMetadata();
  {$IFEND}
End.
