unit P4G_Legend;

{
  Pascal for GIS (P4G) legend control.

  Author:    Phil Hess.
  Copyright: Copyright (C) Phil Hess.
  License:   Modified LGPL (see Free Pascal's rtl/COPYING.FPC).
}

{$IFDEF FPC}
  {$mode objfpc}{$H+}
{$ENDIF}

interface

uses
  SysUtils,
  Classes, 
  Controls,
  CheckLst,
  P4G_Layer;

type
  TP4G_CustomLegend = class(TCustomCheckListBox)
  private
    FMapCtrl : TControl;
    procedure LayerItemClick(Sender : TObject;
                             Index  : Integer);
  public
    constructor Create(AOwner : TComponent); override;
    property MapCtrl : TControl read FMapCtrl write FMapCtrl;
  end;


  TP4G_Legend = class(TP4G_CustomLegend)
  published
    property Align;
    property Anchors;
    property Color;
    property Constraints;
    property Font;
    property ItemHeight;
  end;

procedure Register;


implementation

constructor TP4G_CustomLegend.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  MultiSelect := True;
  TabStop := False;
  OnItemClick := {$IFDEF FPC_OBJFPC}@{$ENDIF}LayerItemClick;
end;


procedure TP4G_CustomLegend.LayerItemClick(Sender : TObject;
                                           Index  : Integer);
begin
  if Assigned(Items.Objects[Index]) and
     (TP4G_Layer(Items.Objects[Index]).Visible <> Checked[Index]) then
    begin
    TP4G_Layer(Items.Objects[Index]).Visible := Checked[Index];
    end;
end;


procedure Register;
begin
  RegisterComponents('Pascal for GIS', [TP4G_Legend]);
end;


end.
